#!/usr/bin/env python3

# Input validator

import sys

st = {2, 3, 4, 5, 6, 7, 8}

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, m = (int(x) for x in fi.readline().split())
if 4 > n or n > 600:
    sys.exit('N out of range')
if 0 > m or m > 600:
    sys.exit('M out of range')
print(n, m, file=fo)

if n > 7:
    st.discard(2)
if n > 25:
    st.discard(3)
if n != m:
    st.discard(4)

g = {i + 1: set() for i in range(n)}
ab = []
for i in range(m):
    a, b = (int(x) for x in fi.readline().split())
    if 1 > a or a >= b:
        sys.exit(f'A[{1 + i}] out of range')
    if a >= b or b > n:
        sys.exit(f'B[{1 + i}] out of range')
    if b in g[a]:
        sys.exit(f'Duplicate line {a}-{b}')
    g[a].add(b)
    g[b].add(a)
    ab.append((a, b))
    print(a, b, file=fo)

for i in range(m):
    ai, bi = ab[i]
    for j in range(i):
        aj, bj = ab[j]
        if aj == ai or aj == bi or bj == ai or bj == bi:
            continue
        if aj in g[ai] and bj in g[bi]:
            sys.exit(f'4-cycle {aj}-{ai}-{bi}-{bj}-{aj}')
        if aj in g[bi] and bj in g[ai]:
            sys.exit(f'4-cycle {aj}-{bi}-{ai}-{bj}-{aj}')

def dfs(i, s = set()):
    if i in s:
        return 0
    s.add(i)
    n = 1
    for j in g[i]:
        n += dfs(j, s)
    return n
if dfs(1) != n:
    st.discard(5)

if min(len(g[i + 1]) for i in range(n)) == 0:
    st.discard(6)

if sum(1 for i in range(n) if len(g[i + 1]) == 0) != 1:
    st.discard(7)

fi.close()
fo.close()

if len(sys.argv) > 4 and sys.argv[4] == '-v':
    print('subtasks:', *st)
