// generates random intervals. with probability p, instead picks a random existing interval
// and generates a subinterval of that

#include <cstdint>
#include "testlib.h"

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  int n = opt<int>("n");
  int m = opt<int>("m");
  double p = opt<double>("p");

  cout << n << " " << m << '\n';
  vector<pair<int, int>> intervals;
  for (int i = 0; i < n; i++) {
    if (intervals.empty() || rnd.next(1.0) > p) {
      int l = rnd.next(1, m);
      int r = rnd.next(1, m);
      if (l > r)
        swap(l, r);

      intervals.emplace_back(l, r);
    } else {
      auto existing = intervals[rnd.next(intervals.size())];
      int l = rnd.next(existing.first, existing.second);
      int r = rnd.next(existing.first, existing.second);
      if (l > r)
        swap(l, r);

      intervals.emplace_back(l, r);
    }
  }

  shuffle(intervals.begin(), intervals.end());

  for (auto I : intervals)
    cout << I.first << " " << I.second << '\n';
}
