# Python translation of the official solution from the CF problem

# Python's built-in set is not sorted and does not have a lower-bound method

# inserts v into set s whose domain is lo..hi; returns the updated set
def insert(v, s, lo, hi):
    assert lo <= v and v <= hi
    if lo == hi:
        return v
    los, his = (None, None) if s == None else (s[0], s[1])
    mi = (lo + hi) // 2
    if v <= mi:
        return (insert(v, los, lo, mi), his)
    else:
        return (los, insert(v, his, mi + 1, hi))

# returns the smallest value that is at least v in set s whose domain is lo..hi, or None
def lbound(v, s, lo, hi):
    assert v <= hi
    if lo == hi:
        return None if s == None else lo
    los, his = (None, None) if s == None else (s[0], s[1])
    mi = (lo + hi) // 2
    if v <= mi:
        lb = None if los == None else lbound(v, los, lo, mi)
        if lb != None: return lb
    return None if his == None else lbound(v, his, mi + 1, hi)

n, m = (int(x) for x in input().split())

seg = []
for _ in range(n):
    seg.append(tuple(int(x) for x in input().split()))

ans = [0 for _ in range(n)]

for _ in range(2):
    ord = [i for i in range(n)]
    ord.sort(key = lambda i : (seg[i][0], -seg[i][1]))

    bounds = None
    for i in ord:
        lb = lbound(seg[i][1], bounds, 1, m)
        if lb != None:
            ans[i] += lb - seg[i][1]
        bounds = insert(seg[i][1], bounds, 1, m)

    for i in range(n):
        l, r = seg[i]
        seg[i] = (m - r + 1, m - l + 1)

cnt = {}
for s in seg:
    cnt[s] = cnt.get(s, 0) + 1
for i in range(n):
    if cnt[seg[i]] > 1:
        ans[i] = 0

for a in ans:
    print(a)
