#include <iostream>
#include <vector>
#include <map>
using namespace std;

typedef long long ll;

int main() {
	ll n, m, q;
	cin >> n >> m >> q;

	map<ll, ll> perm;
	for (auto i = m; i > 0; --i) {
		ll a, b;
		cin >> a >> b;
		const auto on_a = perm.contains(a) ? perm[a] : a;
		const auto on_b = perm.contains(b) ? perm[b] : b;
		perm[a] = on_b;
		perm[b] = on_a;
	}

	map<ll, int> cid, cpos;
	vector<vector<ll>> cycles;
	for (const auto & [a, _] : perm) {
		if (cid.contains(a)) continue;
		vector<ll> c;
		for (auto b = a; b != a or c.empty(); b = perm[b]) {
			cid[b] = cycles.size();
			cpos[b] = c.size();
			c.push_back(b);
		}
		cycles.push_back(c);
	}

	for (auto i = q; i > 0; --i) {
		ll p, t;
		cin >> p >> t;
		if (perm.contains(p)) {
			const auto & c = cycles[cid[p]];
			const auto s = c.size();
			p = c[((t / s + 1) * s + cpos[p] - t) % s];
		}
		cout << p << '\n';
	}
}
